/* mhc.c ...Motorola S data <-> Intel Hex data Converter Ver 1.0.3 */
/* 1998/9/20  Kazuhiko Mori(COW) (C)Cow Project Workshop */
/* e-mail:cow@he.mirai.ne.jp */
/* This Program is Free Soft */
/* This version for Unix,Win32,OS/2 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <sys/stat.h>

/* function prototype */
int m2h(char *in,char *out);
int h2m(char *in,char *out);
int ch2num(char ch1,char ch2);

int main(int argc,char *argv[])/*Main routine*/
{
  int i;
  char inf[255],outf[255],flg[8];

  i = 0;/*Set return code*/
  printf("mhc Ver1.0.3 Motorola S data <-> Intel Hex data Converter.\n");
  printf("(C)1997-1998 Cow Project Workshop.\n");
  if(argc == 4){ /* Parameter check*/
    strcpy(flg,argv[1]);
    strcpy(inf,argv[2]);
    strcpy(outf,argv[3]);
    printf("Convert flag %s\nInput file %s\nOutput file %s\n\n",flg,inf,outf);
    flg[1] = tolower(flg[1]);
    if(0 == strcmp(flg,"-h")){
      printf("Making Intel Hex file.\n");
      i = m2h(inf,outf);
    }
    else {
      if(0 == strcmp(flg,"-m")){
	  printf("Making Motorola S file.\n");
	  i = h2m(inf,outf);
      }
      else {
      	printf("Flag Error!\n");
        i = 3;
      }
    }
    printf("Finished!\n");
    return i;
  }
  else { /*Error Infomation*/
    printf("Parameter Error!\n\nUsage: mhc flag input_file output_file\n\n");
    printf("  flag: -h Convert to Intel Hex data.\n"
           "        -m Convert to Motorola S data.\n\n"
           "Try again!\n");
    return -1;
  }
}

int m2h(char *in,char *out)/*Motorola S to Hex convert*/
{
  FILE *inp, *outp;
  int lsize,dtype,csum,po,nxt;
  char lbuf[255];
  struct stat statbuf;
  long adrs,oadrs;

  /*Open file check*/
  if((inp = fopen(in, "rb")) == NULL){
    printf("Cannot open input file.\n");
    return 1;
  }
  if((outp = fopen(out, "wt")) == NULL){
    printf("Cannot open output file.\n");
    return 1;
  }
  fstat(fileno(inp), &statbuf);
  printf("Input file size=%ld\n",statbuf.st_size);

  adrs = 0; oadrs = 0;
  fprintf(outp,":02000002%04X%02X\n",0,(~4+1)&0xff);
  while (NULL != fgets(lbuf,254,inp)){/*Loop until end of file*/
    if((lbuf[0] != 'S')||(!isalnum(lbuf[1]))) {
    	continue;
    }
    dtype = ch2num('0',lbuf[1]);
    lsize = ch2num(lbuf[2],lbuf[3]) * 2;
    switch (dtype) {
     case 0:
        break;
     case 1:
    	adrs = (long)(ch2num(lbuf[4],lbuf[5])) * 0x100L 
		+ (long)(ch2num(lbuf[6],lbuf[7]));
     	fprintf(outp,":%02X%04X00",lsize/2-3,adrs&0xffff);
     	csum = lsize/2 - 3 + ch2num(lbuf[4],lbuf[5]) 
			+ ch2num(lbuf[6],lbuf[7]);
     	nxt = 8;lsize=lsize-4;
     	break;
     case 2:
    	adrs = (long)(ch2num(lbuf[4],lbuf[5])) * 0x10000L 
		+ (long)(ch2num(lbuf[6],lbuf[7])) * 0x100L 
		+ (long)(ch2num(lbuf[8],lbuf[9]));
     	if(oadrs != (adrs&0xf0000)){
        	fprintf(outp,":02000002%04X%02X\n",
		((adrs>>16)&0xff)*0x1000L,
		0xff&(~(4+0x10*(adrs>>16))+1));
     	}
        fprintf(outp,":%02X%04X00",lsize/2-4,adrs&0xffff);
     	csum = lsize/2 - 4 + ch2num(lbuf[6],lbuf[7]) + ch2num(lbuf[8],lbuf[9]);
     	nxt = 10;lsize=lsize-6;
     	break;
     case 3:
     	adrs = (long)(ch2num(lbuf[4],lbuf[5])) * 0x1000000L 
		+ (long)(ch2num(lbuf[6],lbuf[7])) * 0x10000L 
		+ (long)(ch2num(lbuf[8],lbuf[9])) * 0x100L 
		+ (long)(ch2num(lbuf[10],lbuf[11]));
     	if(oadrs != (adrs&0xf0000)){
        	fprintf(outp,":02000002%04X%02X\n",
			((adrs>>16)&0xff)*0x1000L,
			0xff&(~(4+0x10*(adrs>>16))+1));
     	}
        fprintf(outp,":%02X%04X00",lsize/2-5,adrs&0xffff);
     	csum = lsize/2 - 5 + ch2num(lbuf[8],lbuf[9]) + ch2num(lbuf[10],lbuf[11]);
     	nxt = 12;lsize=lsize-8;
     	break;
     default :
     	adrs = 0;
     	fprintf(outp,":00000001FF\n");
     	break;
    }
    oadrs = adrs & 0xf0000;
    if(0xfffff < adrs) {/*Address check*/
    	printf("Address error!\n");
		fclose(inp);
		fclose(outp);
        return 5;
    }
    if((dtype>=1)&&(dtype<=3)){
     for(po = nxt;po < (lsize+nxt-2);po=po+2){
	fprintf(outp,"%02X",ch2num(lbuf[po],lbuf[po+1]));/*Write data*/
	csum = csum + ch2num(lbuf[po],lbuf[po+1]);
     }
     csum = (~csum + 1) & 0xff;
     fprintf(outp,"%02X\n",csum);
    }
  }

  fstat(fileno(outp), &statbuf);
  printf("Output file size=%ld\n",statbuf.st_size);

  fclose(inp);
  fclose(outp);
  return 0;
}

int h2m(char *in,char *out)/*Hex to Mtorola S convert*/
{
  FILE *inp, *outp;
  int lsize,dmode,csum;
  char lbuf[256];
  struct stat statbuf;
  long po,adrs,ofsa,abadrs;

  /*Open file check*/
  if((inp = fopen(in, "rt")) == NULL){
    printf("Cannot open input file.\n");
    return 1;
  }
  if((outp = fopen(out, "wb")) == NULL){
    printf("Cannot open output file.\n");
    return 1;
  }
  fstat(fileno(inp), &statbuf);
  printf("Input file size=%ld\n",statbuf.st_size);

  adrs = 0; ofsa = 0;
  while (NULL != fgets(lbuf,254,inp)){/*Loop until end of file*/
    if((lbuf[0] != ':')||(!isalnum(lbuf[1]))||(!isalnum(lbuf[2]))) {
    	continue;
    }
    lsize = ch2num(lbuf[1],lbuf[2]) * 2;
    adrs = (long)(ch2num(lbuf[3],lbuf[4])) * 0x100L 
		+ (long)(ch2num(lbuf[5],lbuf[6]));
    if(0xfffff < (ofsa + adrs)) {/*Address check*/
    	printf("Address error!\n");
		fclose(inp);
		fclose(outp);
        return 5;
    }

    dmode = ch2num(lbuf[7],lbuf[8]);/*Get data mode */
    if(dmode == 2) {/*Get offset address*/
    	ofsa = ((long)ch2num(lbuf[9],lbuf[10]) * 0x100L
		+ (long)ch2num(lbuf[11],lbuf[12])) * 0x10L;
        continue;
    }
    if(dmode == 1){/* End of data*/
	fprintf(outp,"S804000000FB\n");
    }
    if(dmode == 0){/*Get Hex data*/
        abadrs = ofsa + adrs;
	csum = 4 + lsize/2 + ((abadrs>>16)&0xff) + ((abadrs>>8)&0xff) + (abadrs&0xff);
	fprintf(outp,"S2%02X%06X",4+lsize/2,abadrs);
        for(po = 9;po < (lsize+9);po=po+2){
	        fprintf(outp,"%02X",ch2num(lbuf[po],lbuf[po+1]));/*Write data*/
		csum = csum + ch2num(lbuf[po],lbuf[po+1]);
        }
	csum = (~csum) & 0xff;
	fprintf(outp,"%02X\n",csum);
    }
  }

  fstat(fileno(outp), &statbuf);
  printf("Output file size=%ld\n",statbuf.st_size);

  fclose(inp);
  fclose(outp);
  return 0;
}

int ch2num(char ch1,char ch2)
{
  int nout;

  if((ch1 >= '0')&&('9' >= ch1)) nout = (ch1 & 0xf) * 0x10;
  else nout = ((ch1 & 0xf) + 9) * 0x10;
  if((ch2 >= '0')&&('9' >= ch2)) return (ch2 & 0xf) + nout;
  else return ((ch2 & 0xf) + 9) + nout;
}

/* Thanks to KITA (QZE01066@nifty.ne.jp) */
/* End of file*/
